<?php

namespace App\Filament\Imports;

use App\Models\PanelBoxValidation;
use Filament\Actions\Imports\ImportColumn;
use Filament\Actions\Imports\Importer;
use Filament\Actions\Imports\Models\Import;

class PanelBoxValidationImporter extends Importer
{
    protected static ?string $model = PanelBoxValidation::class;

    public static function getColumns(): array
    {
        return [
            ImportColumn::make('plant')
                ->requiredMapping()
                ->relationship()
                ->rules(['required']),
            ImportColumn::make('line')
                ->requiredMapping()
                ->relationship()
                ->rules(['required']),
            ImportColumn::make('stickerMaster')
                ->requiredMapping()
                ->relationship()
                ->rules(['required']),
            ImportColumn::make('production_order'),
            ImportColumn::make('serial_number'),
            ImportColumn::make('serial_number_panel'),
            ImportColumn::make('pack_slip_panel'),
            ImportColumn::make('name_plate_panel'),
            ImportColumn::make('tube_sticker_panel'),
            ImportColumn::make('warranty_card_panel'),
            ImportColumn::make('part_validation1'),
            ImportColumn::make('part_validation2'),
            ImportColumn::make('part_validation3'),
            ImportColumn::make('part_validation4'),
            ImportColumn::make('part_validation5'),
            ImportColumn::make('created_by'),
            ImportColumn::make('updated_by'),
            ImportColumn::make('panel_box_supplier'),
            ImportColumn::make('panel_box_serial_number'),
            ImportColumn::make('panel_box_code'),
            ImportColumn::make('inspection_lot_number'),
        ];
    }

    public function resolveRecord(): ?PanelBoxValidation
    {
        // return PanelBoxValidation::firstOrNew([
        //     // Update existing records, matching them by `$this->data['column_name']`
        //     'email' => $this->data['email'],
        // ]);

        return new PanelBoxValidation();
    }

    public static function getCompletedNotificationBody(Import $import): string
    {
        $body = 'Your panel box validation import has completed and ' . number_format($import->successful_rows) . ' ' . str('row')->plural($import->successful_rows) . ' imported.';

        if ($failedRowsCount = $import->getFailedRowsCount()) {
            $body .= ' ' . number_format($failedRowsCount) . ' ' . str('row')->plural($failedRowsCount) . ' failed to import.';
        }

        return $body;
    }
}
